/*
 * usercons.hpp
 *
 *  Created on: 10 août 2015
 *      Author: aekouali
 */

#ifndef SRC_USERCONS_HPP_
#define SRC_USERCONS_HPP_

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string>
#include <cstring>
#include <fstream>
#include <sstream>
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <unordered_map>
#include <cstdlib>
#include <time.h>
#include <algorithm>
#include <iomanip>

using namespace std;

using std::vector;
using std::cout;
using std::cin;
using std::endl;
using std::cerr;
using std::string;
using std::find;

typedef unsigned int uint;

// SCIP Headers

#include <scip/scip.h>
#include <scip/scipdefplugins.h>
#include <scip/cons_linear.h>
#include <scip/scipdefplugins.h>
#include <scip/pub_var.h>
#include <objscip/objscip.h>
#include "objscip/objbranchrule.h"

using namespace scip;

#include "scip_exception.hpp"
#include "wrappers.hpp"

/** C++ constraint handler */
class UserConshdlr: public scip::ObjConshdlr {

public:
	/** default constructor */
	UserConshdlr(SCIP* scip) :
			ObjConshdlr(scip, "User", "User Constraint", 1000000, 0, -2000000,
					1, 1, 1, -1, FALSE, FALSE, FALSE, TRUE,
					SCIP_PROPTIMING_BEFORELP) {
	}
	/** destructor */
	virtual ~UserConshdlr() {
	}
	virtual SCIP_DECL_CONSDELETE (scip_delete);
	virtual SCIP_DECL_CONSTRANS (scip_trans);
	virtual SCIP_DECL_CONSENFOLP (scip_enfolp);
	virtual SCIP_DECL_CONSENFOPS (scip_enfops);
	virtual SCIP_DECL_CONSCHECK (scip_check);
	virtual SCIP_DECL_CONSLOCK (scip_lock);
	virtual SCIP_DECL_CONSPROP (scip_prop);
};

SCIP_RETCODE SCIPcreateUserCons(SCIP* scip, SCIP_CONS** cons, const char* name,
		uint first, /**< the first information */
		uint second /**< the second information */
		);

#endif /* SRC_USERCONS_HPP_ */
